package cat.hack3.codingtests.marsrover;

public class MarsRover {
    private final MarsMap marsMap;
    private Coordinates currentCoordinates;
    private Direction currentDirection;

    public MarsRover(MarsMap marsMap, Coordinates startingCoordinates, Direction startingDirection) {
        this.marsMap = marsMap;
        currentCoordinates = startingCoordinates;
        currentDirection = startingDirection;
    }

    public Coordinates moveForward() {
        return currentCoordinates = currentCoordinates.getNextPositionTowards(currentDirection);
    }

    public Coordinates moveBackwards() {
        return currentCoordinates = currentCoordinates.getNextPositionTowards(currentDirection.reversed());
    }

    public Direction turnLeft() {
        currentDirection = currentDirection.changeDirectionToLeft();
        return currentDirection;
    }

    public Coordinates getCurrentCoordinates() {
        return currentCoordinates;
    }

    public Direction getCurrentDirection() {
        return currentDirection;
    }
}
